package net.lenkaspace.adaptiveNavigation.model;

public class Connection {
	
	public static final int MAX_AGE = 10000; //200 time units
	private int targetId;
	private double weight;
	private int age;
	
	public Connection(int targetId_, double weight_) {
		this.targetId = targetId_;
		this.weight = weight_;
		this.age = 0;
	}
	
	/**
	 * Copies attributes from another connection, used during cloning
	 * @param connection
	 */
	public void copyFromConnection(Connection connection) {
		this.targetId = connection.targetId;
		this.weight = connection.weight;
		this.age = connection.age;
	}

	public void setAge(int age) {
		if (age > Connection.MAX_AGE) {
			age = Connection.MAX_AGE;
		} else if (age < 0) {
			age = 0;
		}
		this.age = age;
	}

	public int getAge() {
		return age;
	}

	public void setWeight(double weight) {
		if (weight > 1) {
			weight = 1;
		} else if (weight < -1) {
			weight = -1;
		}
		this.weight = weight;
		// connection changed, reset age
		this.age = 0;
	}

	public double getWeight() {
		return weight;
	}

	public void setTargetId(int targetId) {
		this.targetId = targetId;
	}

	public int getTargetId() {
		return targetId;
	}
	
}
