package net.lenkaspace.adaptiveNavigation.reports;


import java.awt.BorderLayout;
import java.awt.Color;
import java.awt.Dimension;


import javax.swing.JFrame;
import javax.swing.JPanel;
import javax.swing.JTextPane;

import net.lenkaspace.adaptiveNavigation.Maths;
import net.lenkaspace.adaptiveNavigation.Settings;


public class BaseTextReport {
	
	protected Dimension size;
	
	public BaseTextReport(Dimension size_) {
		size = size_;	
	}
	
	public void display (String title_, ReportController rc) {
		JFrame frame = new JFrame(title_);	
		frame.setSize((int)size.width,(int)size.height);
		frame.setDefaultCloseOperation(JFrame.DISPOSE_ON_CLOSE);
		frame.setLocation((int)(Settings.WINDOW_W/2 - size.width/2),(int)(Settings.WINDOW_H/2- size.height/2));
		
		frame.setEnabled(true); 
		frame.setFocusable(true);
		frame.setResizable(false);
		
		JPanel contentPanel = new JPanel();
		contentPanel.setBackground(Color.WHITE);
		
		JTextPane output = new JTextPane();	
		output.setPreferredSize(new Dimension(size.width-20, size.height-20));
		contentPanel.add(output);
		
		//construct output:
		
		String outputString = "AVERAGE TIME BUMPING: " + Maths.formatDouble(rc.getAverageBumps()) + "%\n";
		outputString += "AVERAGE SPEED: " + Maths.formatDouble(rc.getAverageSpeed()) + "\n";
		outputString += "COVERED GROUND :"+ Maths.formatDouble(rc.getGroundCovered()[1]) + "%\n" ;
		//outputString += rc.getTotalAverageBumps() + "  " + rc.getTotalAverageBumpsSince();
		output.setText(outputString);
		
		
		frame.getContentPane().add(contentPanel, BorderLayout.CENTER);
		frame.setVisible(true);
				
        
	}
}
