package net.lenkaspace.adaptiveNavigation.vo;

public class Vector3D implements Comparable {
	
	public double x;
	public double y;
	public double z;
	
	public Vector3D(double x_,double y_,double z_)
	{
		x=x_;
		y=y_;
		z=z_;
	}
	
	public Vector3D(Vector3D anotherVec_)
	{
		x=anotherVec_.x;
		y=anotherVec_.y;
		z=anotherVec_.z;
	}
	
	public Vector3D()
	{
		x= 0;
		y= 0;
		z= 0;
	} 
	
	double getMagnitude(){
		return (double) Math.sqrt (x*x + y*y + z*z );
	}
	
	public void normalize()
	{
		double tol = 0.0001;
		double m = Math.sqrt((x* x + (y*y) + (z*z)));
		if (m <= tol) { m=1; }
		x /= m;
		y /=m;
		z /=m;

		if (Math.abs(x) < tol){x = 0;}
		if (Math.abs(y) < tol){y = 0;}
		if (Math.abs(z) < tol){z = 0;}
	}
	
	public void multiplyBy(double number) {
		this.x *= number;
		this.y *= number;
		this.z *= number;
	}
	
	public static Vector3D subtractVectors(Vector3D  vec1,Vector3D  vec2)
	{		
		return new Vector3D (vec1.x-vec2.x, vec1.y-vec2.y, vec1.z-vec2.z);
	}
	
	public static Vector3D addVectors(Vector3D vec1, Vector3D vec2){
		return new Vector3D (vec1.x+vec2.x, vec1.y+vec2.y, vec1.z+vec2.z);
	};
	
	double dotProduct (Vector3D v){
		return (x*v.x + y*v.y + z*v.z);
	}

	

	
	
	public static Vector3D CalculateCrossProduct(Vector3D  vec1, Vector3D vec2)
	{
		return new Vector3D ( (vec1.y*vec2.z) - (vec1.z*vec2.y),
							(vec1.z*vec2.x) - (vec1.x*vec2.z),
							(vec1.x*vec2.y) - (vec1.y*vec2.x));
	}
	
	public boolean equals(Object o) {
		Vector3D anotherVec = (Vector3D)o;
		if ((int)anotherVec.x == (int)this.x && (int)anotherVec.y == (int)this.y && (int)anotherVec.z == (int)this.z) {
			return true;
		}
		return false;
	}

	public int compareTo(Object o) {
		//int temp = this.x.
		if (this.equals(o)) {
			return 0;
			
		} else {
			return 1;
		}
		
	}



	


	
}
